/* mgcClone.c was originally generated by the autoSql program, which also 
 * generated mgcClone.h and mgcClone.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "gbSql.h"
#include "mgcClone.h"


void mgcCloneStaticLoad(char **row, struct mgcClone *ret)
/* Load a row from mgcClone table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
ret->id_clone = sqlSigned(row[0]);
ret->id_vendor = sqlSigned(row[1]);
ret->id_lib = sqlSigned(row[2]);
ret->flc_id = gbSqlSignedNull(row[3]);
ret->plate = sqlSigned(row[4]);
ret->row = row[5];
ret->col = sqlSigned(row[6]);
ret->create_date = row[7];
ret->series = row[8];
ret->id_sequencer = gbSqlSignedNull(row[9]);
}

struct mgcClone *mgcCloneLoad(char **row)
/* Load a mgcClone from row fetched with select * from mgcClone
 * from database.  Dispose of this with mgcCloneFree(). */
{
struct mgcClone *ret;

AllocVar(ret);
ret->id_clone = gbSqlSignedNull(row[0]);
ret->id_vendor = sqlSigned(row[1]);
ret->id_lib = sqlSigned(row[2]);
ret->flc_id = sqlSigned(row[3]);
ret->plate = sqlSigned(row[4]);
ret->row = cloneString(row[5]);
ret->col = sqlSigned(row[6]);
ret->create_date = cloneString(row[7]);
ret->series = cloneString(row[8]);
ret->id_sequencer = gbSqlSignedNull(row[9]);
return ret;
}

struct mgcClone *mgcCloneLoadAll(char *fileName) 
/* Load all mgcClone from a whitespace-separated file.
 * Dispose of this with mgcCloneFreeList(). */
{
struct mgcClone *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[10];

while (lineFileRow(lf, row))
    {
    el = mgcCloneLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct mgcClone *mgcCloneCommaIn(char **pS, struct mgcClone *ret)
/* Create a mgcClone out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new mgcClone */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->id_clone = sqlSignedComma(&s);
ret->id_vendor = sqlSignedComma(&s);
ret->id_lib = sqlSignedComma(&s);
ret->flc_id = sqlSignedComma(&s);
ret->plate = sqlSignedComma(&s);
ret->row = sqlStringComma(&s);
ret->col = sqlSignedComma(&s);
ret->create_date = sqlStringComma(&s);
ret->series = sqlStringComma(&s);
ret->id_sequencer = sqlSignedComma(&s);
*pS = s;
return ret;
}

void mgcCloneFree(struct mgcClone **pEl)
/* Free a single dynamically allocated mgcClone such as created
 * with mgcCloneLoad(). */
{
struct mgcClone *el;

if ((el = *pEl) == NULL) return;
freeMem(el->row);
freeMem(el->create_date);
freeMem(el->series);
freez(pEl);
}

void mgcCloneFreeList(struct mgcClone **pList)
/* Free a list of dynamically allocated mgcClone's */
{
struct mgcClone *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    mgcCloneFree(&el);
    }
*pList = NULL;
}

void mgcCloneOutput(struct mgcClone *el, FILE *f, char sep, char lastSep) 
/* Print out mgcClone.  Separate fields with sep. Follow last field with lastSep. */
{
fprintf(f, "%d", el->id_clone);
fputc(sep,f);
fprintf(f, "%d", el->id_vendor);
fputc(sep,f);
fprintf(f, "%d", el->id_lib);
fputc(sep,f);
fprintf(f, "%d", el->flc_id);
fputc(sep,f);
fprintf(f, "%d", el->plate);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->row);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->col);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->create_date);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->series);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->id_sequencer);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

